﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using TestSdkFacebook.Classes;
using Facebook.Client;
using System.Threading.Tasks;

namespace TestSdkFacebook
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
        }

        async private void BouConnexion_Click(object sender, RoutedEventArgs e)
        {
            if (!FacebookManager.IsAuthenticated)
            {
                await AuthAsync();
            }
            else
            {
                this.NavigationService.Navigate(new Uri("/Pages/UserInfoPage.xaml", UriKind.Relative));
            }
        }

        private async Task AuthAsync()
        {
            try
            {
                var wFacebookSession = await FacebookManager.SessionClient.LoginAsync("user_about_me,read_stream");
                FacebookManager.AccessToken = wFacebookSession.AccessToken;
                FacebookManager.FacebookId = wFacebookSession.FacebookId;
                FacebookManager.IsAuthenticated = true;

                this.NavigationService.Navigate(new Uri("/Pages/UserInfoPage.xaml", UriKind.Relative));
            }
            catch (Exception ex)
            {
                String wMessage = "Login impossible !\n\n" + ex.Message;
                MessageBox.Show(wMessage);
            }
        }
    }
}