﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Facebook;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using TestSdkFacebook.Classes;

namespace TestSdkFacebook.Pages
{
    public partial class FriendsPage : PhoneApplicationPage
    {
        public FriendsPage()
        {
            InitializeComponent();
        }

        async protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            if (FacebookManager.UserFriends == null)
            {
                await GetUserFriendsAsync();
            }
            else
            {
                LstFriends.ItemsSource = FacebookManager.UserFriends;
            }
        }

        async private Task GetUserFriendsAsync()
        {
            var wFacebook = new FacebookClient(FacebookManager.AccessToken);
            var wResult = await wFacebook.GetTaskAsync("/me/friends") as IDictionary<String, Object>;

            if (wResult != null)
            {
                // Formats de l'image
                // square (50x50)
                // small (50x?)
                // normal (100x?)
                // large (200x?)

                var wData = wResult["data"] as IEnumerable<Object>;
                var wFriends = new ObservableCollection<Friend>();

                foreach (var wItem in wData)
                {
                    var wDicoFriend = wItem as IDictionary<String, Object>;

                    String wId = wDicoFriend["id"] as String;
                    String wName = wDicoFriend["name"] as String;
                    String wPictureUrl = String.Format("https://graph.facebook.com/{0}/picture?type={1}&access_token={2}", wId, "square", FacebookManager.AccessToken);

                    var wFriend = new Friend();
                    wFriend.Id = wId;
                    wFriend.Name = wName;
                    wFriend.Picture = new System.Windows.Media.Imaging.BitmapImage(new Uri(wPictureUrl));

                    wFriends.Add(wFriend);
                }

                FacebookManager.UserFriends = wFriends;
                LstFriends.ItemsSource = FacebookManager.UserFriends;
            }
        }
    }
}