﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Facebook;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using TestSdkFacebook.Classes;

namespace TestSdkFacebook.Pages
{
    public partial class SearchPage : PhoneApplicationPage
    {
        private ProgressIndicator pProgressIndicator;

        public SearchPage()
        {
            InitializeComponent();

            pProgressIndicator = new ProgressIndicator();
            pProgressIndicator.IsIndeterminate = true;
            pProgressIndicator.IsVisible = false; ;

            SystemTray.SetIsVisible(this, true);
            SystemTray.SetProgressIndicator(this, pProgressIndicator);
        }

        async private void BouRechercher_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(TxtRecherche.Text))
            {
                IsEnabled = false;

                pProgressIndicator.Text = "Recherche en cours...";
                pProgressIndicator.IsVisible = true;

                await GetPagesAsync(TxtRecherche.Text);
            }
        }

        async private Task GetPagesAsync(string wPageName)
        {
            var wQuery = string.Format("/search?q={0}&type=page", wPageName);
            var wFacebook = new FacebookClient(FacebookManager.AccessToken);
            var wPages = new ObservableCollection<FacebookPage>();

            try
            {
                var wResult = await wFacebook.GetTaskAsync(wQuery) as IDictionary<string, Object>;

                if (wResult != null)
                {
                    var wData = wResult["data"] as IEnumerable<Object>;

                    foreach (var wItem in wData)
                    {
                        var wDicoPages = wItem as IDictionary<string, Object>;

                        string wId = wDicoPages["id"] as string;
                        string wName = wDicoPages["name"] as string;
                        string wCategorie = wDicoPages["category"] as string;
                        string wPictureUrl = string.Format("https://graph.facebook.com/{0}/picture?type={1}&access_token={2}", wId, "normal", FacebookManager.AccessToken);

                        var wPage = new FacebookPage();
                        wPage.Id = wId;
                        wPage.Name = wName;
                        wPage.Category = wCategorie;
                        wPage.Picture = new System.Windows.Media.Imaging.BitmapImage(new Uri(wPictureUrl));

                        wPages.Add(wPage);
                    }
                }
            }
            catch (Exception ex)
            {
                TxtRecherche.Text = "";
                MessageBox.Show("Recherche impossible !");
            }

            FacebookManager.SearchResult = wPages;
            LstPages.ItemsSource = wPages;

            pProgressIndicator.IsVisible = false;
            IsEnabled = true;
        }
    }
}