﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using Facebook;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using TestSdkFacebook.Classes;

namespace TestSdkFacebook.Pages
{
    public partial class UserInfoPage : PhoneApplicationPage
    {
        public UserInfoPage()
        {
            InitializeComponent();
        }

        async protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            if (FacebookManager.UserProfile == null)
            {
                await GetUserProfileAsync();
            }
            else
            {
                this.DataContext = FacebookManager.UserProfile;
            }
        }

        async private Task GetUserProfileAsync()
        {
            var wFacebook = new FacebookClient(FacebookManager.AccessToken);
            var wResult = await wFacebook.GetTaskAsync("me") as IDictionary<String, Object>;

            if (wResult != null)
            {
                // Formats de l'image
                // square (50x50)
                // small (50x?)
                // normal (100x?)
                // large (200x?)

                String wPrenom = wResult["first_name"] as String;
                String wNom = wResult["last_name"] as String;
                String wPictureUrl = String.Format("https://graph.facebook.com/{0}/picture?type={1}&access_token={2}", FacebookManager.FacebookId, "large", FacebookManager.AccessToken);

                var wUserProfile = new UserProfile();
                wUserProfile.Name = String.Format("{0} {1}", wPrenom, wNom);
                wUserProfile.Picture = new BitmapImage(new Uri(wPictureUrl));

                FacebookManager.UserProfile = wUserProfile;

                this.DataContext = FacebookManager.UserProfile;
            }
        }

        void OnFacebookGetCompleted(object sender, FacebookApiEventArgs e)
        {
            if (e.Error != null)
            {
                // Il s'est passé un problème

                String wMessage = "Impossible de récupérer le profile de l'utilisateur !\n\n" + e.Error.Message;
                MessageBox.Show(wMessage);
            }
            else
            {
                var wResult = e.GetResultData() as IDictionary<String, Object>;

                this.Dispatcher.BeginInvoke(() =>
                {
                    String wPrenom = wResult["first_name"] as String;
                    String wNom = wResult["last_name"] as String;
                    String wPictureUrl = String.Format("https://graph.facebook.com/{0}/picture?type={1}&access_token={2}", FacebookManager.FacebookId, "square", FacebookManager.AccessToken);

                    var wUserProfile = new UserProfile();
                    wUserProfile.Name = String.Format("{0} {1}", wPrenom, wNom);
                    wUserProfile.Picture = new System.Windows.Media.Imaging.BitmapImage(new Uri(wPictureUrl, UriKind.Absolute));

                    FacebookManager.UserProfile = wUserProfile;

                    this.DataContext = FacebookManager.UserProfile;
                });
            }
        }

        private void BouListerAmis_Click(object sender, RoutedEventArgs e)
        {
            this.NavigationService.Navigate(new Uri("/Pages/FriendsPage.xaml", UriKind.Relative));
        }

        private void BouRechercherPages_Click(object sender, RoutedEventArgs e)
        {
            this.NavigationService.Navigate(new Uri("/Pages/SearchPage.xaml", UriKind.Relative));
        }
    }
}